<template>
  <v-container class="pt-10">
    <v-row>
      <v-col md="6">
        <p class="title font-weight-bold">Review your circle</p>
        <p class="body-1">{{ circleDescription }}</p>
        <p class="body-1">Start date:</p>
        <v-select
          v-if="circle && circle.dateItem"
          v-model="circle.dateItem.date"
          :items="[circle && circle.dateItem && circle.dateItem.date]"
          class="mt-3"
          outlined
          item-text="type"
          item-value="value"
          hide-details
          required
          dense
        ></v-select>
        <v-date-picker
          v-if="circle && circle.dateItem"
          class="mt-3 full-width"
          :value="circle && circle.dateItem && circle.dateItem.date"
          :min="moment().toISOString()"
          :show-current="moment().toISOString()"
        />
      </v-col>
      <v-col md="6">
        <v-row>
          <v-col md="6" offset-md="2">
            <h1 class="font-weight-bold">{{ circle && circle.title }}</h1>
            <p class="body-1">
              <b> Hosted by:</b>
              {{ circle && circle.facilitator && circle.facilitator.firstName }}
            </p>
            <p class="body-1">
              <i class="far fa-clock"></i><b> Duration:</b>
              {{ duration }}
            </p>
            <p class="body-1">
              <i class="far fa-calendar-alt"></i><b> Frequency:</b>
              {{
                circle && circle.frequency && circle.frequency.type === 'week'
                  ? 'weekly'
                  : circle && circle.frequency && circle.frequency.type
              }}
            </p>
            <p class="body-1">
              <i class="fas fa-users"></i><b> Group Size:</b>
              {{ circle && circle.numOfParticipants }}
            </p>
          </v-col>
          <v-col md="3" offset-md="1">
            <v-avatar size="200">
              <v-img :src="circle && circle.imageUrl"></v-img>
            </v-avatar>
          </v-col>
        </v-row>
        <v-row>
          <v-col md="10" offset-md="2">
            <p class="body-1">{{ circle && circle.description }}</p>
          </v-col>
        </v-row>
        <v-row>
          <v-col md="10" offset-md="2">
            <v-text-field
              v-if="circle && circle.price"
              solo
              disabled
              :value="'Price: ' + circle && circle.price + '$'"
            ></v-text-field>
          </v-col>
        </v-row>
        <v-row>
          <v-col md="10" offset-md="2">
            <p class="title-1 font-weight-bold">Cancellations</p>
            <p class="title-2">
              For recurring groups, cancel 48 hours before a session for a full
              refund of any upcoming charges under our cancellation policy.
            </p>
          </v-col>
        </v-row>
        <v-row>
          <v-col md="10" offset-md="2">
            <p class="title-1 font-weight-bold">Requirements</p>
            <p class="title-2">
              You'll need an internet connection and the ability to stream audio
              and video to participate. A link and details on how to join will
              be included in your booking confirmation email. Guests ages 18 and
              up can attend.
            </p>
          </v-col>
        </v-row>
      </v-col>
    </v-row>

    <template v-if="user.card">
      <v-row v-if="!booked">
        <v-col md="6">
          <v-btn-toggle v-model="whichCard">
            <v-btn text color="primary">Use saved card</v-btn>
            <v-btn text color="primary">Add new one</v-btn>
          </v-btn-toggle>
        </v-col>
      </v-row>
      <v-row v-if="whichCard === 0">
        <v-col md="4">
          <v-text-field
            disabled
            outlined
            :value="`xxx-xxx-xxx-${user.card.last4}`"
          ></v-text-field>
        </v-col>
      </v-row>
      <v-row v-if="showCardErr && whichCard === null">
        <v-col md="6" style="color: red;">
          You must choose card.
        </v-col>
      </v-row>
      <v-row
        ><v-col md="6">
          <v-btn
            v-if="!whichCard"
            class="align-center"
            block
            color="primary"
            :disabled="disableBook || loading || bookChecking || booked"
            outlined
            :loading="bookLoading"
            @click="bookCircle"
            >{{ bookName }}</v-btn
          >
        </v-col>
      </v-row>
    </template>
    <v-row v-if="!user.card || whichCard">
      <v-col md="6">
        <Stripe :payment-type="'bookCircle'" />
      </v-col>
    </v-row>
    <!--    <v-row>-->
    <!--      <v-col><p>Start date:</p></v-col>-->
    <!--    </v-row>-->
  </v-container>
</template>

<script>
import { mapState } from 'vuex'
import Stripe from '@/components/Shared/Payment/index'
import EventBus from '@/event-bus'
// import EventBus from '@/event-bus'

export default {
  components: {
    Stripe
  },
  data: () => ({
    disableBook: false,
    bookLoading: false,
    loading: false,
    booked: false,
    bookChecking: true,
    whichCard: null,
    showCardErr: false
  }),
  computed: {
    ...mapState('authentication', ['user']),
    ...mapState('circle', ['circle']),
    bookName() {
      return this.booked ? 'This circle is already booked' : 'BookCircle'
    },
    circleDescription() {
      return this.circle && this.circle.recurringGroup
        ? 'This is a recurring circle. You will be charged each time the session is held.'
        : 'This is one time circle. You will be charged only 1 time for this session.'
    },
    hr() {
      return (
        this.circle &&
        this.circle.sessionDuration &&
        this.circle.sessionDuration.hr
      )
    },
    min() {
      return (
        this.circle &&
        this.circle.sessionDuration &&
        this.circle.sessionDuration.min
      )
    },
    duration() {
      if (this.hr && this.min) {
        return this.hr > 1
          ? `${this.hr}
          hours and
          ${this.min} minutes`
          : `${this.hr}
          hour and
          ${this.min} minutes`
      }
      if (this.hr && !this.min) {
        return this.hr > 1 ? `${this.hr} hours` : `${this.hr} hour`
      }
      // if (!this.circle.sessionDuration.hr && this.circle.sessionDuration.min) {
      return `${this.min} minutes`
      // }
    }
  },
  created() {
    EventBus.$on('callBookCircle', () => {
      this.$forceUpdate()
    })
  },

  beforeMount() {},
  mounted() {
    console.log(this.whichCard)
    this.$store.dispatch('circle/getCircle', this.$route.params.id).then(() => {
      this.bookChecking = true
      this.$store
        .dispatch('circle/checkBookedCircle', this.circle.id)
        .then(res => {
          this.loading = false
          this.booked = res
          this.bookChecking = false
          this.$forceUpdate()
        })
        .catch(err => {
          this.loading = false
          this.bookChecking = false
          console.log(err)
        })
    })
  },
  watch: {
    whichCard: {
      handler(card) {
        console.log(card)
      }
    }
  },
  methods: {
    bookCircle() {
      if (!this.booked && this.whichCard !== null) {
        this.book = false
        if (!this.disableBook && this.user.card) {
          this.enterCard = false
          this.bookLoading = true
          this.$store
            .dispatch('circle/addCircleToUser', this.circle.id)
            .then(res => {
              console.log(res)
              this.bookLoading = false
              this.book = !this.book
              if (res.data && res.data.status) {
                this.bookFinish = true
                this.booked = true
                this.$router.push('/dashboard')
              } else {
                this.errorHappened = true
                this.bookError = res.data.message ? res.data.message : null
              }
            })
            .catch(err => {
              console.log(err)
              this.errorHappened = true
              this.bookLoading = false
              this.bookFinish = false
              this.errorHappened = true
              this.bookError = err.data.message ? err.data.message : null
            })
        } else {
          this.enterCard = true
        }
      } else {
        this.showCardErr = true
      }
    }
  }
}
</script>

<style lang="css" scoped>
.img {
  width: 900px;
  height: 900px;
}

/*.v-picker__body theme--light {*/
/*  width: 100% !important;*/
/*}*/
.full-width {
  width: 100% !important;
}
.v-text-field input {
  font-weight: bold !important;
}
</style>
